class Entry

  require 'nyaa_anime'

  attr_reader :title, :link, :hashless, :distro_episode, :distro_meta, :subber, :series, :episode, :last_ep, :meta

  def initialize(title, link=nil)
    @title = title
    @link = link
    match = @title.scan(/\A(\[[^\[\]]+\])?[_\s]*(.+?)[_\s]*-?[_\s]*(\d+(\.\d+)?(v\d+)?|\d+-\d+)[_\s]+((?!-).+?)[_\s]*(\[\w{8,}\])?[_\s]*(\.\w+)*\z/)
    if match[0].nil?
      match[0] = ['undefined', 'undefined', 'undefined', nil, nil, 'undefined']
    end
    @subber, @series, @episode, @meta = match[0].values_at(0, 1, 2, 5)
    @episode, @last_ep = @episode.split("-").map { |ep| ep.to_i }
    @last_ep ||= @episode
    @distro_episode = "#{@subber} #{@series} #{@episode}"
    @distro_meta = "#{@subber} #{@series} #{@meta}"
    @hashless = "#{@subber} #{@series} #{@episode} #{@meta}"
  end

  def ==(other)
    @title == other.title &&
      @link == other.link
  end

  def <=>(other)
    if @title == other.title
      @link <=> other.link
    else
      @title <=> other.title
    end
  end

  def to_s
    @hashless
  end

  def first_ep
    @episode
  end

end
